//+------------------------------------------------------------------+
//|                                                           11.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

#include <Canvas\Canvas.mqh>
CCanvas canvas_PANEL;


string CanvasPanel = "|NewsPanel| ";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
      if (ObjectFind(CanvasPanel) == -1) 
      {
      canvas_PANEL.CreateBitmapLabel(CanvasPanel,0,100,1,1,COLOR_FORMAT_ARGB_NORMALIZE);
      ObjectSetInteger(0,CanvasPanel,OBJPROP_CORNER,2); 
      ObjectSetInteger(0,CanvasPanel,OBJPROP_ZORDER,0);
      
      canvas_PANEL.Resize(400,200);
      canvas_PANEL.FillRectangle(100-6,12,400,200-2, ARGB(200,110,110,110));
      canvas_PANEL.FillRectangle(100-3,12*3+2,400-5,200-5, ARGB(200,140,140,140));
      canvas_PANEL.Update();
      }
      
      out_Label("Arrow", "U", 16, "Webdings", Red, 2, ANCHOR_CENTER, 200, 50); //   . //U
      
      
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

void out_Label(string name, string text, int font_size, string font_name, color col, int corner, int Anchor, int X, int Y) {//  
   if (ObjectFind(name) < 0) { 
      ObjectCreate(name,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_CORNER,corner);
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,Anchor);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_BACK,true);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false); 
   }
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,X);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,Y);
   ObjectSetInteger(0,name,OBJPROP_ZORDER,9);
   ObjectSetText(name,text,font_size,font_name,col); 
} 


void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam) {
   if (id == CHARTEVENT_OBJECT_CLICK) { 
   
      if (ObjectType(sparam) == OBJ_LABEL && sparam == "Arrow") {
         Print("!");
      }
   }      

}